include "core.js";
include "dom.js";
include "events.js";
include "views.js";
include "stylesheets.js";
include "css.js";
include "html2.js";

/*
class Global {
	var document:HTMLDocument;
}
*/
interface Embed {
	var align:String;
	var height:Number;
	var src:String;
	var width:Number;
}

interface Screen {
	var width:Number;
	var height:Number;
	var bufferDepth:Number;
	var colorDepth:Number;
	var deviceXDPI:Number;
	var deviceYDPI:Number;
	var logicalXDPI:Number;
	var logicalYDPI:Number;
}

interface UserProfile {
	function addReadRequest(sAttributeName:String, vReserved:Boolean=false):Boolean;
	function clearRequest():void;
	function doReadRequest(vUsageCode:String, vFriendlyName:String=null, vDomain:String=null, vPath:String=null, vExpiration:Object, vReserved:Boolean=false):void;
	function getAttribute(sAttributeName:String):String;
	function setAttribute(sName:String, vValue:Object, iFlags:Number=1):void;
}

interface Navigator {
	var appCodeName:String;
	var appMinorVersion:String;
	var appName:String;
	var appVersion:String;
	var browserLanguage:String;
	var cookieEnabled:Boolean;
	var cpuClass:Object;
	var onLine:Boolean;
	var platform:String;
	var systemLanguage:String;
	var userAgent:String;
	var userLanguage:String;
	
	var plugins:Embed[];
	
	var userProfile:UserProfile;
	
	function javaEnabled():Boolean;
	function taintEnabled():Boolean;
}

interface ClientInformation {
	var appCodeName:String;
	var appMinorVersion:String;
	var appName:String;
	var appVersion:String;
	var browserLanguage:String;
	var cookieEnabled:Boolean;
	var cpuClass:Object;
	var onLine:Boolean;
	var platform:String;
	var systemLanguage:String;
	var userAgent:String;
	var userLanguage:String;
	
	var plugins:Embed[];
	
	var userProfile:UserProfile;
	
	function javaEnabled():Boolean;
	function taintEnabled():Boolean;
}

interface ClipboardData {
	function clearData(sDataFormat:String=null):void;
	function getData(sDataFormat:String):String;
	function setData(sDataFormat:String, sData:String):Boolean;
}

interface Location {
	var hash:String;
	var host:String;
	var hostname:String;
	var href:String;
	var pathname:String;
	var port:String;
	var protocol:String;
	var search:String;
	
	function assign(sURL:String):void;
	function reload(bReloadSource:Boolean=false):void;
	function replace(sURL:String):void;
}

interface External {
	var menuArguments:Object;
	
	function AddChannel(sURLToCDF:String):void;
	function AddDesktopComponent(sURL:String, sType:String, iLeft:Number=0, iTop:Number=0, iWidth:Number=0, iHeight:Number=0):void;
	function AddFavorite(sURL:String, sTitle:String=null):void;
	function AutoCompleteSaveForm(oForm:Object):void;
	function AutoScan(sUserQuery:String, sURL:String, sTarget:String=null):void;
	function ImportExportFavorites(bImportExport:Boolean, sImportExportPath:String=null):void;
	function IsSubscribed(sURLToCDF:String):void;
	function NavigateAndFind(sLocation:String, sQuery:String, sTargetFrame:String):void;
	function ShowBrowserUI(sUI:Stirng, Null:Object):void;
}

interface History {
	var length:Number;
	
	function back(iDistance:Number):void;
	function forward():void;
	function go(vLocation):void;
}

interface HTMLDocument {
	var activeElement:HTMLElement;
	var alinkColor:Object;
	var bgColor:Object;
	var charset:String;
	var compatMode:String;
	var defaultCharset:String;
	var designMode:String;
	var dir:String;
	var expando:Boolean;
	var fgColor:Object;
	var fileCreatedDate:String;
	var fileModifiedDate:String;
	var fileSize:String;
	var lastModified:String;
	var linkColor:Object;
	var parentWindow:Window;
	var protocol:String;
	var readyState:String;
	var uniqueID:String;
	var vlinkColor:String;
	var URLUnencoded:String;
	//var XMLDocument:String;
	//var XSLDocument:String;
	
	var location:Location;
	
	var all:HTMLCollection;

	//Event
	function onactivate():void;
	function onbeforeactivate():void;
	function onbeforecut():void;
	function onbeforedeactivate():void;
	function onbeforeeditfocus():void;
	function onbeforepaste():void;
	function onclick():void;
	function oncontextmenu():void;
	function oncontrolselect():void;
	function oncut():void;
	function ondblclick():void;
	function ondeactivate():void;
	function ondrag():void;
	function ondragend():void;
	function ondragenter():void;
	function ondragleave():void;
	function ondragover():void;
	function ondragstart():void;
	function ondrop():void;
	function onfocusin():void;
	function onfocusout():void;
	function onhelp():void;
	function onkeydown():void;
	function onkeypress():void;
	function onkeyup():void;
	function onmousedown():void;
	function onmousemove():void;
	function onmouseout():void;
	function onmouseover():void;
	function onmouseup():void;
	function onmousewheel():void;
	function onmove():void;
	function onmoveend():void;
	function onmovestart():void;
	function onpaste():void;
	function onpropertychange():void;
	function onreadystatechange():void;
	function onresizeend():void;
	function onresizestart():void;
	function onselectionchange():void;
	function onstop():void;

	function attachEvent(sEvent:String, fpNotify:Function):Boolean;
	function clear():void;
	function createEventObject(oExistingEvent:Object):Event;
	function createStyleSheet(sURL:String, iIndex:Number):StyleSheet;
	function detachEvent(sEvent:String, fpNotify:Function):void;
	function elementFromPoint(iX:Number, iY:Number):HTMLElement;
	function execCommand(sCommand:String, bUserInterface:Boolean=false, vValue:Object=null):void;
	function focus():void;
	function hasFocus():Boolean;
	function mergeAttributes(oSource:Object, bPreserve:Boolean=false):void;
	function queryCommandEnabled(sCmdID:String):Boolean;
	function queryCommandIndeterm(sCmdID:String):Boolean;
	function queryCommandState(sCmdID:String):Boolean;
	function queryCommandSupported(sCmdID:String):Boolean;
	function queryCommandValue(sCmdID:String):Object;
	function recalc(bForceAll:Boolean=false):void;
	function releaseCapture():void;
	function setActive():void;
}

interface Window {
	var closed:Boolean;
	var defaultStatus:String;
	var dialogArguments:Object;
	var dialogHeight:Number;
	var dialogLeft:Number;
	var dialogTop:Number;
	var dialogWidth:Number;
	var frameElement:Frame;
	var length:Number;
	var name:String;
	var offscreenBuffering:Boolean
	var opener:Window;
	var parent:Window;
	var returnValue:Object;
	var screenLeft:Number;
	var screenTop:Number;
	var self:Window;
	var status:String;
	var top:Number;
	var frames:Window[];
	
	var clientInformation:ClientInformation;
	var clipboardData:ClipboardData;
	var document:HTMLDocument;
	var event:Event;
	var external:External;
	var history:History;
	var location:Location;
	var navigator:Navigator;
	var screen:Screen;
	
	//Event
	function onactivate();
	function onafterprint();
	function onbeforedeactivate();
	function onbeforeprint();
	function onbeforeunload();
	function onblur();
	function oncontrolselect();
	function ondeactivate();
	function onerror();
	function onfocus();
	function onhelp();
	function onload();
	function onmove();
	function onmoveend();
	function onmovestart();
	function onresize();
	function onresizeend();
	function onresizestart();
	function onscroll();
	function onunload();
	
	function alert(sMessage:String=null):void;
	function attachEvent(sEvent:String, fpNotify:Function):Boolean;
	function blur():void;
	function clearInterval(iIntervalID:Number):void;
	function clearTimeout(iTimeoutID:Number):void;
	function close():void;
	function confirm(sMessage:String):Boolean;
	function createPopup(vArgs:Object=null):Window;
	function detachEvent(sEvent:String, fpNotify:Function):void;
	function execScript(sExpression:String, sLanguage:String):void;
	function focus():void;
	function moveBy(iX:Number, iY:Number):void;
	function moveTo(iX:Number, iY:Number):void;
	function navigate(sURL:String):void;
	function open(sURL:String=null, sName:String=null, sFeatures:String=null, bReplace:Boolean=false):Window;
	function print():void;
	function prompt(sMessage:String=null, sDefaultValue:String=null):String;
	function resizeBy(iX:Number, iY:Number):void;
	function resizeTo(iWidth:Number, iHeight:Number):void;
	function scroll(iX:Number, iY:Number):void;
	function scrollBy(iX:Number, iY:Number):void;
	function scrollTo(iX:Number, iY:Number):void;
	function setActive():void;
	function setInterval(vCode:Object, iMilliSeconds:Number=0, sLanguage:String=null):Number;
	function setTimeout(vCode:Object, iMilliSeconds:Number=0, sLanguage:String=null):Number;
	function showHelp(sURL:String, vContextID:Object=null):void;
	function showModalDialog(sURL:String, vArguments:Object=null, sFeatures:String=null):Object;
	function showModelessDialog(sURL:String, vArguments:Object=null, sFeatures:String=null):Object;
}
